
from datetime import datetime
from decimal import Decimal

class AiResult:
    """Interface of the application data type AiResult. 
       Generated by: EASy-Producer."""
 
    
    def getError(self) -> list:
        """Returns the value of {@code error}. Error class names (TBD).
        
           Returns:
             - the value of error"""
        raise NotImplementedError
    
    def getErrorConfidence(self) -> list:
        """Returns the value of {@code errorConfidence}. Confidence values (0;1) for error classes in errors.
        
           Returns:
             - the value of errorConfidence"""
        raise NotImplementedError
    
    def getImageUri(self) -> str:
        """Returns the value of {@code imageUri}.
        
           Returns:
             - the value of imageUri"""
        raise NotImplementedError
    
    def getRobotId(self) -> int:
        """Returns the value of {@code robotId}.
        
           Returns:
             - the value of robotId"""
        raise NotImplementedError
    
    def getAiId(self) -> str:
        """Returns the value of {@code aiId}. Unique id of AI (e.g., static, flower).
        
           Returns:
             - the value of aiId"""
        raise NotImplementedError
    
    def getModelId(self) -> str:
        """Returns the value of {@code modelId}. Active AI model id.
        
           Returns:
             - the value of modelId"""
        raise NotImplementedError
    
    
    def setError(self, v: list):
        """Changes the value of {@code error}. Error class names (TBD).
        
           Parameters:
             - v -- the new value of error"""
        raise NotImplementedError
    
    def setErrorConfidence(self, v: list):
        """Changes the value of {@code errorConfidence}. Confidence values (0;1) for error classes in errors.
        
           Parameters:
             - v -- the new value of errorConfidence"""
        raise NotImplementedError
    
    def setImageUri(self, v: str):
        """Changes the value of {@code imageUri}.
        
           Parameters:
             - v -- the new value of imageUri"""
        raise NotImplementedError
    
    def setRobotId(self, v):
        """Changes the value of {@code robotId}.
        
           Parameters:
             - v -- the new value of robotId, may be of type int or the corresponding numpy type"""
        raise NotImplementedError
    
    def setAiId(self, v: str):
        """Changes the value of {@code aiId}. Unique id of AI (e.g., static, flower).
        
           Parameters:
             - v -- the new value of aiId"""
        raise NotImplementedError
    
    def setModelId(self, v: str):
        """Changes the value of {@code modelId}. Active AI model id.
        
           Parameters:
             - v -- the new value of modelId"""
        raise NotImplementedError
    
    
    #Indeed, there are 2.4 decorators for this, but for now we want to have all here: pythonic field access
    #backed by getter/setter and the ability to replace data classes by e.g. projecting or data enhancing
    #functionality (original idea of the "interfaces" with similar naming as in Java. It may be that the 
    #interfaces become superfluous due to the properties, but let's leave them in for now.
    error = property(getError, setError)
    errorConfidence = property(getErrorConfidence, setErrorConfidence)
    imageUri = property(getImageUri, setImageUri)
    robotId = property(getRobotId, setRobotId)
    aiId = property(getAiId, setAiId)
    modelId = property(getModelId, setModelId)
    
