from datatypes.AiResult import AiResult
from datetime import datetime
from decimal import Decimal

class AiResultImpl(AiResult):
    """Implementation of the application data type AiResult. 
       Generated by: EASy-Producer."""
 
    #Mapped into properties without leading _ below resembling getter/setter
    
    _error: list = None
    _errorConfidence: list = None
    _imageUri: str = ""
    _robotId: int = 0
    _aiId: str = ""
    _modelId: str = ""
    
    def getError(self) -> list:
        """Returns the value of {@code error}. Error class names (TBD).
        
           Returns:
             - the value of error"""
        return self._error
    
    def getErrorConfidence(self) -> list:
        """Returns the value of {@code errorConfidence}. Confidence values (0;1) for error classes in errors.
        
           Returns:
             - the value of errorConfidence"""
        return self._errorConfidence
    
    def getImageUri(self) -> str:
        """Returns the value of {@code imageUri}.
        
           Returns:
             - the value of imageUri"""
        return self._imageUri
    
    def getRobotId(self) -> int:
        """Returns the value of {@code robotId}.
        
           Returns:
             - the value of robotId"""
        return self._robotId
    
    def getAiId(self) -> str:
        """Returns the value of {@code aiId}. Unique id of AI (e.g., static, flower).
        
           Returns:
             - the value of aiId"""
        return self._aiId
    
    def getModelId(self) -> str:
        """Returns the value of {@code modelId}. Active AI model id.
        
           Returns:
             - the value of modelId"""
        return self._modelId
    
    
    def setError(self, v: list):
        """Changes the value of {@code error}. Error class names (TBD).
        
           Parameters:
             - v -- the new value of error"""
        tmp = []
        for e in v:
            if ("numpy" in str(type(e))):
                tmp.append(e.item())
            else:
                tmp.append(e)
        self._error = tmp
    
    def setErrorConfidence(self, v: list):
        """Changes the value of {@code errorConfidence}. Confidence values (0;1) for error classes in errors.
        
           Parameters:
             - v -- the new value of errorConfidence"""
        tmp = []
        for e in v:
            if ("numpy" in str(type(e))):
                tmp.append(e.item())
            else:
                tmp.append(e)
        self._errorConfidence = tmp
    
    def setImageUri(self, v: str):
        """Changes the value of {@code imageUri}.
        
           Parameters:
             - v -- the new value of imageUri"""
        self._imageUri = v
    
    def setRobotId(self, v):
        """Changes the value of {@code robotId}.
        
           Parameters:
             - v -- the new value of robotId, may be of type int or the corresponding numpy type"""
        if ("numpy" in str(type(v))):
            self._robotId = v.item()
        else:
            self._robotId = v
    
    def setAiId(self, v: str):
        """Changes the value of {@code aiId}. Unique id of AI (e.g., static, flower).
        
           Parameters:
             - v -- the new value of aiId"""
        self._aiId = v
    
    def setModelId(self, v: str):
        """Changes the value of {@code modelId}. Active AI model id.
        
           Parameters:
             - v -- the new value of modelId"""
        self._modelId = v
    
    
    #Indeed, there are 2.4 decorators for this, but for now we want to have all here: pythonic field access
    #backed by getter/setter and the ability to replace data classes by e.g. projecting or data enhancing
    #functionality (original idea of the "interfaces" with similar naming as in Java. It may be that the 
    #interfaces become superfluous due to the properties, but let's leave them in for now.
    error = property(getError, setError)
    errorConfidence = property(getErrorConfidence, setErrorConfidence)
    imageUri = property(getImageUri, setImageUri)
    robotId = property(getRobotId, setRobotId)
    aiId = property(getAiId, setAiId)
    modelId = property(getModelId, setModelId)
    
