from datatypes.DecisionResult import DecisionResult
from datetime import datetime
from decimal import Decimal

class DecisionResultImpl(DecisionResult):
    """Implementation of the application data type DecisionResult. 
       Generated by: EASy-Producer."""
 
    #Mapped into properties without leading _ below resembling getter/setter
    
    _io: bool = None
    _ioReason: int = 0
    _error: list = None
    _errorConfidence: list = None
    _img1Error: list = None
    _img2Error: list = None
    _img3Error: list = None
    _imageUri: list = None
    _robotId: int = 0
    _aiId: str = ""
    _modelId: str = ""
    
    def getIo(self) -> bool:
        """Returns the value of {@code io}.
        
           Returns:
             - the value of io"""
        return self._io
    
    def getIoReason(self) -> int:
        """Returns the value of {@code ioReason}.
        
           Returns:
             - the value of ioReason"""
        return self._ioReason
    
    def getError(self) -> list:
        """Returns the value of {@code error}. Error class names (TBD).
        
           Returns:
             - the value of error"""
        return self._error
    
    def getErrorConfidence(self) -> list:
        """Returns the value of {@code errorConfidence}. Confidence values (0;1) for error classes in errors.
        
           Returns:
             - the value of errorConfidence"""
        return self._errorConfidence
    
    def getImg1Error(self) -> list:
        """Returns the value of {@code img1Error}. Error class names for image 1 (TBD).
        
           Returns:
             - the value of img1Error"""
        return self._img1Error
    
    def getImg2Error(self) -> list:
        """Returns the value of {@code img2Error}. Error class names for image 2 (TBD).
        
           Returns:
             - the value of img2Error"""
        return self._img2Error
    
    def getImg3Error(self) -> list:
        """Returns the value of {@code img3Error}. Error class names for image 3 (TBD).
        
           Returns:
             - the value of img3Error"""
        return self._img3Error
    
    def getImageUri(self) -> list:
        """Returns the value of {@code imageUri}.
        
           Returns:
             - the value of imageUri"""
        return self._imageUri
    
    def getRobotId(self) -> int:
        """Returns the value of {@code robotId}.
        
           Returns:
             - the value of robotId"""
        return self._robotId
    
    def getAiId(self) -> str:
        """Returns the value of {@code aiId}. Unique id of AI (Lenze, ISMLL, RapidMiner).
        
           Returns:
             - the value of aiId"""
        return self._aiId
    
    def getModelId(self) -> str:
        """Returns the value of {@code modelId}. Active AI model id.
        
           Returns:
             - the value of modelId"""
        return self._modelId
    
    
    def setIo(self, v: bool):
        """Changes the value of {@code io}.
        
           Parameters:
             - v -- the new value of io"""
        if ("numpy" in str(type(v))):
            self._io = v.item()
        else:
            self._io = v
    
    def setIoReason(self, v):
        """Changes the value of {@code ioReason}.
        
           Parameters:
             - v -- the new value of ioReason, may be of type int or the corresponding numpy type"""
        if ("numpy" in str(type(v))):
            self._ioReason = v.item()
        else:
            self._ioReason = v
    
    def setError(self, v: list):
        """Changes the value of {@code error}. Error class names (TBD).
        
           Parameters:
             - v -- the new value of error"""
        tmp = []
        for e in v:
            if ("numpy" in str(type(e))):
                tmp.append(e.item())
            else:
                tmp.append(e)
        self._error = tmp
    
    def setErrorConfidence(self, v: list):
        """Changes the value of {@code errorConfidence}. Confidence values (0;1) for error classes in errors.
        
           Parameters:
             - v -- the new value of errorConfidence"""
        tmp = []
        for e in v:
            if ("numpy" in str(type(e))):
                tmp.append(e.item())
            else:
                tmp.append(e)
        self._errorConfidence = tmp
    
    def setImg1Error(self, v: list):
        """Changes the value of {@code img1Error}. Error class names for image 1 (TBD).
        
           Parameters:
             - v -- the new value of img1Error"""
        tmp = []
        for e in v:
            if ("numpy" in str(type(e))):
                tmp.append(e.item())
            else:
                tmp.append(e)
        self._img1Error = tmp
    
    def setImg2Error(self, v: list):
        """Changes the value of {@code img2Error}. Error class names for image 2 (TBD).
        
           Parameters:
             - v -- the new value of img2Error"""
        tmp = []
        for e in v:
            if ("numpy" in str(type(e))):
                tmp.append(e.item())
            else:
                tmp.append(e)
        self._img2Error = tmp
    
    def setImg3Error(self, v: list):
        """Changes the value of {@code img3Error}. Error class names for image 3 (TBD).
        
           Parameters:
             - v -- the new value of img3Error"""
        tmp = []
        for e in v:
            if ("numpy" in str(type(e))):
                tmp.append(e.item())
            else:
                tmp.append(e)
        self._img3Error = tmp
    
    def setImageUri(self, v: list):
        """Changes the value of {@code imageUri}.
        
           Parameters:
             - v -- the new value of imageUri"""
        tmp = []
        for e in v:
            if ("numpy" in str(type(e))):
                tmp.append(e.item())
            else:
                tmp.append(e)
        self._imageUri = tmp
    
    def setRobotId(self, v):
        """Changes the value of {@code robotId}.
        
           Parameters:
             - v -- the new value of robotId, may be of type int or the corresponding numpy type"""
        if ("numpy" in str(type(v))):
            self._robotId = v.item()
        else:
            self._robotId = v
    
    def setAiId(self, v: str):
        """Changes the value of {@code aiId}. Unique id of AI (Lenze, ISMLL, RapidMiner).
        
           Parameters:
             - v -- the new value of aiId"""
        self._aiId = v
    
    def setModelId(self, v: str):
        """Changes the value of {@code modelId}. Active AI model id.
        
           Parameters:
             - v -- the new value of modelId"""
        self._modelId = v
    
    
    #Indeed, there are 2.4 decorators for this, but for now we want to have all here: pythonic field access
    #backed by getter/setter and the ability to replace data classes by e.g. projecting or data enhancing
    #functionality (original idea of the "interfaces" with similar naming as in Java. It may be that the 
    #interfaces become superfluous due to the properties, but let's leave them in for now.
    io = property(getIo, setIo)
    ioReason = property(getIoReason, setIoReason)
    error = property(getError, setError)
    errorConfidence = property(getErrorConfidence, setErrorConfidence)
    img1Error = property(getImg1Error, setImg1Error)
    img2Error = property(getImg2Error, setImg2Error)
    img3Error = property(getImg3Error, setImg3Error)
    imageUri = property(getImageUri, setImageUri)
    robotId = property(getRobotId, setRobotId)
    aiId = property(getAiId, setAiId)
    modelId = property(getModelId, setModelId)
    
