from datatypes.AggregatedPlcEnergyMeasurement import AggregatedPlcEnergyMeasurement
from datatypes.LenzeDriveMeasurement import LenzeDriveMeasurement
from datetime import datetime
from decimal import Decimal

class DriveAiResult:
    """Interface of the application data type DriveAiResult. 
       Generated by: EASy-Producer."""
 
    
    def getIo(self) -> bool:
        """Returns the value of {@code io}. Overall result: Is drive run ok or not.
        
           Returns:
             - the value of io"""
        raise NotImplementedError
    
    def getError(self) -> list:
        """Returns the value of {@code error}. Error class names (TBD).
        
           Returns:
             - the value of error"""
        raise NotImplementedError
    
    def getErrorConfidence(self) -> list:
        """Returns the value of {@code errorConfidence}. Confidence values (0;1) for error classes in errors.
        
           Returns:
             - the value of errorConfidence"""
        raise NotImplementedError
    
    def getAiId(self) -> str:
        """Returns the value of {@code aiId}. Unique id of AI (Lenze, ISMLL, RapidMiner).
        
           Returns:
             - the value of aiId"""
        raise NotImplementedError
    
    def getEnergy(self) -> AggregatedPlcEnergyMeasurement:
        """Returns the value of {@code energy}. Pass through input of energy data for UI/visu.
        
           Returns:
             - the value of energy"""
        raise NotImplementedError
    
    def getDrive(self) -> LenzeDriveMeasurement:
        """Returns the value of {@code drive}. Pass through input of drive data for UI/visu.
        
           Returns:
             - the value of drive"""
        raise NotImplementedError
    
    
    def setIo(self, v: bool):
        """Changes the value of {@code io}. Overall result: Is drive run ok or not.
        
           Parameters:
             - v -- the new value of io"""
        raise NotImplementedError
    
    def setError(self, v: list):
        """Changes the value of {@code error}. Error class names (TBD).
        
           Parameters:
             - v -- the new value of error"""
        raise NotImplementedError
    
    def setErrorConfidence(self, v: list):
        """Changes the value of {@code errorConfidence}. Confidence values (0;1) for error classes in errors.
        
           Parameters:
             - v -- the new value of errorConfidence"""
        raise NotImplementedError
    
    def setAiId(self, v: str):
        """Changes the value of {@code aiId}. Unique id of AI (Lenze, ISMLL, RapidMiner).
        
           Parameters:
             - v -- the new value of aiId"""
        raise NotImplementedError
    
    def setEnergy(self, v: AggregatedPlcEnergyMeasurement):
        """Changes the value of {@code energy}. Pass through input of energy data for UI/visu.
        
           Parameters:
             - v -- the new value of energy"""
        raise NotImplementedError
    
    def setDrive(self, v: LenzeDriveMeasurement):
        """Changes the value of {@code drive}. Pass through input of drive data for UI/visu.
        
           Parameters:
             - v -- the new value of drive"""
        raise NotImplementedError
    
    
    #Indeed, there are 2.4 decorators for this, but for now we want to have all here: pythonic field access
    #backed by getter/setter and the ability to replace data classes by e.g. projecting or data enhancing
    #functionality (original idea of the "interfaces" with similar naming as in Java. It may be that the 
    #interfaces become superfluous due to the properties, but let's leave them in for now.
    io = property(getIo, setIo)
    error = property(getError, setError)
    errorConfidence = property(getErrorConfidence, setErrorConfidence)
    aiId = property(getAiId, setAiId)
    energy = property(getEnergy, setEnergy)
    drive = property(getDrive, setDrive)
    
