from datatypes.DriveAiResult import DriveAiResult
from datatypes.AggregatedPlcEnergyMeasurement import AggregatedPlcEnergyMeasurement
from datatypes.LenzeDriveMeasurement import LenzeDriveMeasurement
from datetime import datetime
from decimal import Decimal

class DriveAiResultImpl(DriveAiResult):
    """Implementation of the application data type DriveAiResult. 
       Generated by: EASy-Producer."""
 
    #Mapped into properties without leading _ below resembling getter/setter
    
    _io: bool = None
    _error: list = None
    _errorConfidence: list = None
    _aiId: str = ""
    _energy: AggregatedPlcEnergyMeasurement = None
    _drive: LenzeDriveMeasurement = None
    
    def getIo(self) -> bool:
        """Returns the value of {@code io}. Overall result: Is drive run ok or not.
        
           Returns:
             - the value of io"""
        return self._io
    
    def getError(self) -> list:
        """Returns the value of {@code error}. Error class names (TBD).
        
           Returns:
             - the value of error"""
        return self._error
    
    def getErrorConfidence(self) -> list:
        """Returns the value of {@code errorConfidence}. Confidence values (0;1) for error classes in errors.
        
           Returns:
             - the value of errorConfidence"""
        return self._errorConfidence
    
    def getAiId(self) -> str:
        """Returns the value of {@code aiId}. Unique id of AI (Lenze, ISMLL, RapidMiner).
        
           Returns:
             - the value of aiId"""
        return self._aiId
    
    def getEnergy(self) -> AggregatedPlcEnergyMeasurement:
        """Returns the value of {@code energy}. Pass through input of energy data for UI/visu.
        
           Returns:
             - the value of energy"""
        return self._energy
    
    def getDrive(self) -> LenzeDriveMeasurement:
        """Returns the value of {@code drive}. Pass through input of drive data for UI/visu.
        
           Returns:
             - the value of drive"""
        return self._drive
    
    
    def setIo(self, v: bool):
        """Changes the value of {@code io}. Overall result: Is drive run ok or not.
        
           Parameters:
             - v -- the new value of io"""
        if ("numpy" in str(type(v))):
            self._io = v.item()
        else:
            self._io = v
    
    def setError(self, v: list):
        """Changes the value of {@code error}. Error class names (TBD).
        
           Parameters:
             - v -- the new value of error"""
        tmp = []
        for e in v:
            if ("numpy" in str(type(e))):
                tmp.append(e.item())
            else:
                tmp.append(e)
        self._error = tmp
    
    def setErrorConfidence(self, v: list):
        """Changes the value of {@code errorConfidence}. Confidence values (0;1) for error classes in errors.
        
           Parameters:
             - v -- the new value of errorConfidence"""
        tmp = []
        for e in v:
            if ("numpy" in str(type(e))):
                tmp.append(e.item())
            else:
                tmp.append(e)
        self._errorConfidence = tmp
    
    def setAiId(self, v: str):
        """Changes the value of {@code aiId}. Unique id of AI (Lenze, ISMLL, RapidMiner).
        
           Parameters:
             - v -- the new value of aiId"""
        self._aiId = v
    
    def setEnergy(self, v: AggregatedPlcEnergyMeasurement):
        """Changes the value of {@code energy}. Pass through input of energy data for UI/visu.
        
           Parameters:
             - v -- the new value of energy"""
        self._energy = v
    
    def setDrive(self, v: LenzeDriveMeasurement):
        """Changes the value of {@code drive}. Pass through input of drive data for UI/visu.
        
           Parameters:
             - v -- the new value of drive"""
        self._drive = v
    
    
    #Indeed, there are 2.4 decorators for this, but for now we want to have all here: pythonic field access
    #backed by getter/setter and the ability to replace data classes by e.g. projecting or data enhancing
    #functionality (original idea of the "interfaces" with similar naming as in Java. It may be that the 
    #interfaces become superfluous due to the properties, but let's leave them in for now.
    io = property(getIo, setIo)
    error = property(getError, setError)
    errorConfidence = property(getErrorConfidence, setErrorConfidence)
    aiId = property(getAiId, setAiId)
    energy = property(getEnergy, setEnergy)
    drive = property(getDrive, setDrive)
    
