from datatypes.DriveBeckhoffOutput import DriveBeckhoffOutput
from datetime import datetime
from decimal import Decimal

class DriveBeckhoffOutputImpl(DriveBeckhoffOutput):
    """Implementation of the application data type DriveBeckhoffOutput. 
       Generated by: EASy-Producer."""
 
    #Mapped into properties without leading _ below resembling getter/setter
    
    _bWaitForCommand: bool = None
    _iFriction_actual: int = 0
    _iTension_actual: int = 0
    _Error: bool = None
    _ErrorID: int = 0
    _rPosition_actual: float = 0.0
    _sAxisMessage: str = ""
    
    def getBWaitForCommand(self) -> bool:
        """Returns the value of {@code bWaitForCommand}. Combination of Enabled, waiting for command.
        
           Returns:
             - the value of bWaitForCommand"""
        return self._bWaitForCommand
    
    def getIFriction_actual(self) -> int:
        """Returns the value of {@code iFriction_actual}. Actual friction incident (read-only)
        
           Returns:
             - the value of iFriction_actual"""
        return self._iFriction_actual
    
    def getITension_actual(self) -> int:
        """Returns the value of {@code iTension_actual}. Actual tension incident (read-only)
        
           Returns:
             - the value of iTension_actual"""
        return self._iTension_actual
    
    def getError(self) -> bool:
        """Returns the value of {@code Error}. Becomes true in case of an error. See ErrorID.
        
           Returns:
             - the value of Error"""
        return self._Error
    
    def getErrorID(self) -> int:
        """Returns the value of {@code ErrorID}. If error is true, returns an error identification code.
        
           Returns:
             - the value of ErrorID"""
        return self._ErrorID
    
    def getRPosition_actual(self) -> float:
        """Returns the value of {@code rPosition_actual}. Actual position in mm +/- 1mm, may be negative although 0
        
           Returns:
             - the value of rPosition_actual"""
        return self._rPosition_actual
    
    def getSAxisMessage(self) -> str:
        """Returns the value of {@code sAxisMessage}. Status message from drive
        
           Returns:
             - the value of sAxisMessage"""
        return self._sAxisMessage
    
    
    def setBWaitForCommand(self, v: bool):
        """Changes the value of {@code bWaitForCommand}. Combination of Enabled, waiting for command.
        
           Parameters:
             - v -- the new value of bWaitForCommand"""
        if ("numpy" in str(type(v))):
            self._bWaitForCommand = v.item()
        else:
            self._bWaitForCommand = v
    
    def setError(self, v: bool):
        """Changes the value of {@code Error}. Becomes true in case of an error. See ErrorID.
        
           Parameters:
             - v -- the new value of Error"""
        if ("numpy" in str(type(v))):
            self._Error = v.item()
        else:
            self._Error = v
    
    def setErrorID(self, v):
        """Changes the value of {@code ErrorID}. If error is true, returns an error identification code.
        
           Parameters:
             - v -- the new value of ErrorID, may be of type int or the corresponding numpy type"""
        if ("numpy" in str(type(v))):
            self._ErrorID = v.item()
        else:
            self._ErrorID = v
    
    def setRPosition_actual(self, v):
        """Changes the value of {@code rPosition_actual}. Actual position in mm +/- 1mm, may be negative although 0
        
           Parameters:
             - v -- the new value of rPosition_actual, may be of type float or the corresponding numpy type"""
        if ("numpy" in str(type(v))):
            self._rPosition_actual = v.item()
        else:
            self._rPosition_actual = v
    
    def setSAxisMessage(self, v: str):
        """Changes the value of {@code sAxisMessage}. Status message from drive
        
           Parameters:
             - v -- the new value of sAxisMessage"""
        self._sAxisMessage = v
    
    
    #Indeed, there are 2.4 decorators for this, but for now we want to have all here: pythonic field access
    #backed by getter/setter and the ability to replace data classes by e.g. projecting or data enhancing
    #functionality (original idea of the "interfaces" with similar naming as in Java. It may be that the 
    #interfaces become superfluous due to the properties, but let's leave them in for now.
    bWaitForCommand = property(getBWaitForCommand, setBWaitForCommand)
    
    iFriction_actual = property(getIFriction_actual)
    
    iTension_actual = property(getITension_actual)
    Error = property(getError, setError)
    ErrorID = property(getErrorID, setErrorID)
    rPosition_actual = property(getRPosition_actual, setRPosition_actual)
    sAxisMessage = property(getSAxisMessage, setSAxisMessage)
    
