
from datetime import datetime
from decimal import Decimal

class LenzeDriveMeasurementChannel:
    """Interface of the application data type LenzeDriveMeasurementChannel. 
       Generated by: EASy-Producer."""
 
    
    def getChannelNo(self) -> int:
        """Returns the value of {@code channelNo}.
        
           Returns:
             - the value of channelNo"""
        raise NotImplementedError
    
    def getTimestamp(self) -> str:
        """Returns the value of {@code timestamp}. recording point in time
        
           Returns:
             - the value of timestamp"""
        raise NotImplementedError
    
    def getTimebase(self) -> float:
        """Returns the value of {@code timebase}. not relevant
        
           Returns:
             - the value of timebase"""
        raise NotImplementedError
    
    def getSamplerate(self) -> float:
        """Returns the value of {@code samplerate}. sample rate in (fraction of) seconds, time period between two measurements
        
           Returns:
             - the value of samplerate"""
        raise NotImplementedError
    
    def getConnection(self) -> str:
        """Returns the value of {@code connection}. unique ID, IP address of source (converter)
        
           Returns:
             - the value of connection"""
        raise NotImplementedError
    
    def getParameterID(self) -> str:
        """Returns the value of {@code ParameterID}. unique naming of recorded state variable for this channel
        
           Returns:
             - the value of ParameterID"""
        raise NotImplementedError
    
    def getName(self) -> str:
        """Returns the value of {@code name}. name of the parameter
        
           Returns:
             - the value of name"""
        raise NotImplementedError
    
    def getUnit(self) -> str:
        """Returns the value of {@code unit}. unit of recorded data
        
           Returns:
             - the value of unit"""
        raise NotImplementedError
    
    def getData(self) -> str:
        """Returns the value of {@code data}. array of measurements, time axis can be calculated via sample rate
        
           Returns:
             - the value of data"""
        raise NotImplementedError
    
    
    def setChannelNo(self, v):
        """Changes the value of {@code channelNo}.
        
           Parameters:
             - v -- the new value of channelNo, may be of type int or the corresponding numpy type"""
        raise NotImplementedError
    
    def setTimestamp(self, v: str):
        """Changes the value of {@code timestamp}. recording point in time
        
           Parameters:
             - v -- the new value of timestamp"""
        raise NotImplementedError
    
    def setTimebase(self, v):
        """Changes the value of {@code timebase}. not relevant
        
           Parameters:
             - v -- the new value of timebase, may be of type float or the corresponding numpy type"""
        raise NotImplementedError
    
    def setSamplerate(self, v):
        """Changes the value of {@code samplerate}. sample rate in (fraction of) seconds, time period between two measurements
        
           Parameters:
             - v -- the new value of samplerate, may be of type float or the corresponding numpy type"""
        raise NotImplementedError
    
    def setConnection(self, v: str):
        """Changes the value of {@code connection}. unique ID, IP address of source (converter)
        
           Parameters:
             - v -- the new value of connection"""
        raise NotImplementedError
    
    def setParameterID(self, v: str):
        """Changes the value of {@code ParameterID}. unique naming of recorded state variable for this channel
        
           Parameters:
             - v -- the new value of ParameterID"""
        raise NotImplementedError
    
    def setName(self, v: str):
        """Changes the value of {@code name}. name of the parameter
        
           Parameters:
             - v -- the new value of name"""
        raise NotImplementedError
    
    def setUnit(self, v: str):
        """Changes the value of {@code unit}. unit of recorded data
        
           Parameters:
             - v -- the new value of unit"""
        raise NotImplementedError
    
    def setData(self, v: str):
        """Changes the value of {@code data}. array of measurements, time axis can be calculated via sample rate
        
           Parameters:
             - v -- the new value of data"""
        raise NotImplementedError
    
    
    #Indeed, there are 2.4 decorators for this, but for now we want to have all here: pythonic field access
    #backed by getter/setter and the ability to replace data classes by e.g. projecting or data enhancing
    #functionality (original idea of the "interfaces" with similar naming as in Java. It may be that the 
    #interfaces become superfluous due to the properties, but let's leave them in for now.
    channelNo = property(getChannelNo, setChannelNo)
    timestamp = property(getTimestamp, setTimestamp)
    timebase = property(getTimebase, setTimebase)
    samplerate = property(getSamplerate, setSamplerate)
    connection = property(getConnection, setConnection)
    ParameterID = property(getParameterID, setParameterID)
    name = property(getName, setName)
    unit = property(getUnit, setUnit)
    data = property(getData, setData)
    
