
from datetime import datetime
from decimal import Decimal

class MipMqttOutput:
    """Interface of the application data type MipMqttOutput. 
       Generated by: EASy-Producer."""
 
    
    def getMipcontext(self) -> str:
        """Returns the value of {@code mipcontext}.
        
           Returns:
             - the value of mipcontext"""
        raise NotImplementedError
    
    def getMipdate(self) -> str:
        """Returns the value of {@code mipdate}.
        
           Returns:
             - the value of mipdate"""
        raise NotImplementedError
    
    def getMipfrom(self) -> str:
        """Returns the value of {@code mipfrom}.
        
           Returns:
             - the value of mipfrom"""
        raise NotImplementedError
    
    def getMipid_tag(self) -> str:
        """Returns the value of {@code mipid_tag}.
        
           Returns:
             - the value of mipid_tag"""
        raise NotImplementedError
    
    def getMipreader(self) -> str:
        """Returns the value of {@code mipreader}.
        
           Returns:
             - the value of mipreader"""
        raise NotImplementedError
    
    def getMipraw_signal_clock(self) -> str:
        """Returns the value of {@code mipraw_signal_clock}.
        
           Returns:
             - the value of mipraw_signal_clock"""
        raise NotImplementedError
    
    def getMipraw_signal_data1(self) -> str:
        """Returns the value of {@code mipraw_signal_data1}.
        
           Returns:
             - the value of mipraw_signal_data1"""
        raise NotImplementedError
    
    def getMipraw_signal_data2(self) -> str:
        """Returns the value of {@code mipraw_signal_data2}.
        
           Returns:
             - the value of mipraw_signal_data2"""
        raise NotImplementedError
    
    
    def setMipcontext(self, v: str):
        """Changes the value of {@code mipcontext}.
        
           Parameters:
             - v -- the new value of mipcontext"""
        raise NotImplementedError
    
    def setMipdate(self, v: str):
        """Changes the value of {@code mipdate}.
        
           Parameters:
             - v -- the new value of mipdate"""
        raise NotImplementedError
    
    def setMipfrom(self, v: str):
        """Changes the value of {@code mipfrom}.
        
           Parameters:
             - v -- the new value of mipfrom"""
        raise NotImplementedError
    
    def setMipid_tag(self, v: str):
        """Changes the value of {@code mipid_tag}.
        
           Parameters:
             - v -- the new value of mipid_tag"""
        raise NotImplementedError
    
    def setMipreader(self, v: str):
        """Changes the value of {@code mipreader}.
        
           Parameters:
             - v -- the new value of mipreader"""
        raise NotImplementedError
    
    def setMipraw_signal_clock(self, v: str):
        """Changes the value of {@code mipraw_signal_clock}.
        
           Parameters:
             - v -- the new value of mipraw_signal_clock"""
        raise NotImplementedError
    
    def setMipraw_signal_data1(self, v: str):
        """Changes the value of {@code mipraw_signal_data1}.
        
           Parameters:
             - v -- the new value of mipraw_signal_data1"""
        raise NotImplementedError
    
    def setMipraw_signal_data2(self, v: str):
        """Changes the value of {@code mipraw_signal_data2}.
        
           Parameters:
             - v -- the new value of mipraw_signal_data2"""
        raise NotImplementedError
    
    
    #Indeed, there are 2.4 decorators for this, but for now we want to have all here: pythonic field access
    #backed by getter/setter and the ability to replace data classes by e.g. projecting or data enhancing
    #functionality (original idea of the "interfaces" with similar naming as in Java. It may be that the 
    #interfaces become superfluous due to the properties, but let's leave them in for now.
    mipcontext = property(getMipcontext, setMipcontext)
    mipdate = property(getMipdate, setMipdate)
    mipfrom = property(getMipfrom, setMipfrom)
    mipid_tag = property(getMipid_tag, setMipid_tag)
    mipreader = property(getMipreader, setMipreader)
    mipraw_signal_clock = property(getMipraw_signal_clock, setMipraw_signal_clock)
    mipraw_signal_data1 = property(getMipraw_signal_data1, setMipraw_signal_data1)
    mipraw_signal_data2 = property(getMipraw_signal_data2, setMipraw_signal_data2)
    
