from json import JSONEncoder
import json
from datetime import datetime
from TypeTranslatorToString import TypeTranslatorToString
import Registry
from datatypes.AggregatedPlcEnergyMeasurement import AggregatedPlcEnergyMeasurement
from datatypes.AggregatedPlcEnergyMeasurementImpl import AggregatedPlcEnergyMeasurementImpl



from datatypes.PlcEnergyMeasurementChannel import PlcEnergyMeasurementChannel

from serializers.PlcEnergyMeasurementChannelSerializer import PlcEnergyMeasurementChannelSerializer


class AggregatedPlcEnergyMeasurementEncoder(JSONEncoder):
    """JSON encoder class for AggregatedPlcEnergyMeasurement.
    Generated by: EASy-Producer."""

    def default(self, o):
        """Provides access to the attributes in o.
        
        Parameters:
          - o -- the object to serialize
        Returns:
          dict
            the attributes
        """
        tmp = dict()
        for key in o.__dict__:
            k = key[1:] # by generation convention
            tmp[k] = o.__dict__[key]
        
        return tmp
    

class AggregatedPlcEnergyMeasurementSerializer(TypeTranslatorToString):
    """JSON transport serializer for AggregatedPlcEnergyMeasurement.
       Generated by: EASy-Producer."""
                
    def __init__(self):
        """Initializes the transformer.""" 
        Registry.serializers["AggregatedPlcEnergyMeasurement"] = self
        Registry.types[AggregatedPlcEnergyMeasurement] = "AggregatedPlcEnergyMeasurement"
        Registry.serializers["AggregatedPlcEnergyMeasurementImpl"] = self # there is a serializer for the Impl
        Registry.types[AggregatedPlcEnergyMeasurementImpl] = "AggregatedPlcEnergyMeasurement" # the Impl maps back to the type name
    
    def readFrom(self, data: str) -> AggregatedPlcEnergyMeasurement:
        """Turns bytes into a String.
        
        Parameters:
          - data -- the data string
        Returns:
          object
            the deserialized object
        """
    
        result = AggregatedPlcEnergyMeasurementImpl()
        jTmp = json.loads(data)
        tmp = dict()
        for key in jTmp:
            k = "_" + str(key) # by generation convention
            tmp[k] = jTmp[key]
        if "_channels" in tmp:
            tmplist = tmp["_channels"]
            tmp["_channels"] = []
            for i in tmplist: 
                tmp["_channels"].append(PlcEnergyMeasurementChannelSerializer.readFromPlcEnergyMeasurementChannel(i))
                
        
        result.__dict__ = tmp
        return result

    def writeTo(self, source: AggregatedPlcEnergyMeasurement) -> str:
        """Turns an object into a String.
        
        Parameters:
          - source -- the object
        Returns:
          bytes
            the serialized data string
        """
        
        return AggregatedPlcEnergyMeasurementEncoder().encode(source).encode("UTF-8").decode()
        
    def readFromAggregatedPlcEnergyMeasurement(d: dict) -> AggregatedPlcEnergyMeasurement:
        """Turns a dict into an object of type AggregatedPlcEnergyMeasurement for deep deserialization.
        
        Parameters:
          - d -- dict
        Returns:
          AggregatedPlcEnergyMeasurement
            the object, may be None
        """
        if d is None:
            return None
        else:
            tmp = dict()
            result = AggregatedPlcEnergyMeasurementImpl()
            for key in d:
                k = "_" + str(key) # by generation convention
                tmp[k] = d[key]
            if "_channels" in tmp:
                tmplist = tmp["_channels"]
                tmp["_channels"] = []
                for i in tmplist: 
                    tmp["_channels"].append(PlcEnergyMeasurementChannelSerializer.readFromPlcEnergyMeasurementChannel(i))
                    
            
            result.__dict__ = tmp
            return result
    
    def writeToAggregatedPlcEnergyMeasurement(o: AggregatedPlcEnergyMeasurement) -> dict:
        """Turns an object of type AggregatedPlcEnergyMeasurement into a dict for serialization.
        
        Parameters:
          - o -- the object, may be None
        Returns:
          dict
            the dict, may be None
        """
        if o is None:
            return None
        else:
            result = dict()
            for key in o.__dict__:
                k = key[1:] # by generation convention
                result[k] = o.__dict__[key]

AggregatedPlcEnergyMeasurementSerializer()
