from json import JSONEncoder
import json
from datetime import datetime
from TypeTranslatorToString import TypeTranslatorToString
import Registry
from datatypes.DecisionResult import DecisionResult
from datatypes.DecisionResultImpl import DecisionResultImpl












class DecisionResultEncoder(JSONEncoder):
    """JSON encoder class for DecisionResult.
    Generated by: EASy-Producer."""

    def default(self, o):
        """Provides access to the attributes in o.
        
        Parameters:
          - o -- the object to serialize
        Returns:
          dict
            the attributes
        """
        tmp = dict()
        for key in o.__dict__:
            k = key[1:] # by generation convention
            tmp[k] = o.__dict__[key]
        
        return tmp
    

class DecisionResultSerializer(TypeTranslatorToString):
    """JSON transport serializer for DecisionResult.
       Generated by: EASy-Producer."""
                
    def __init__(self):
        """Initializes the transformer.""" 
        Registry.serializers["DecisionResult"] = self
        Registry.types[DecisionResult] = "DecisionResult"
        Registry.serializers["DecisionResultImpl"] = self # there is a serializer for the Impl
        Registry.types[DecisionResultImpl] = "DecisionResult" # the Impl maps back to the type name
    
    def readFrom(self, data: str) -> DecisionResult:
        """Turns bytes into a String.
        
        Parameters:
          - data -- the data string
        Returns:
          object
            the deserialized object
        """
    
        result = DecisionResultImpl()
        jTmp = json.loads(data)
        tmp = dict()
        for key in jTmp:
            k = "_" + str(key) # by generation convention
            tmp[k] = jTmp[key]
        if "_error" in tmp:
            tmplist = tmp["_error"]
            tmp["_error"] = []
            for i in tmplist: 
                tmp["_error"].append(i)
                
        if "_errorConfidence" in tmp:
            tmplist = tmp["_errorConfidence"]
            tmp["_errorConfidence"] = []
            for i in tmplist: 
                tmp["_errorConfidence"].append(i)
                
        if "_img1Error" in tmp:
            tmplist = tmp["_img1Error"]
            tmp["_img1Error"] = []
            for i in tmplist: 
                tmp["_img1Error"].append(i)
                
        if "_img2Error" in tmp:
            tmplist = tmp["_img2Error"]
            tmp["_img2Error"] = []
            for i in tmplist: 
                tmp["_img2Error"].append(i)
                
        if "_img3Error" in tmp:
            tmplist = tmp["_img3Error"]
            tmp["_img3Error"] = []
            for i in tmplist: 
                tmp["_img3Error"].append(i)
                
        if "_imageUri" in tmp:
            tmplist = tmp["_imageUri"]
            tmp["_imageUri"] = []
            for i in tmplist: 
                tmp["_imageUri"].append(i)
                
        
        
        
        
        result.__dict__ = tmp
        return result

    def writeTo(self, source: DecisionResult) -> str:
        """Turns an object into a String.
        
        Parameters:
          - source -- the object
        Returns:
          bytes
            the serialized data string
        """
        
        return DecisionResultEncoder().encode(source).encode("UTF-8").decode()
        
    def readFromDecisionResult(d: dict) -> DecisionResult:
        """Turns a dict into an object of type DecisionResult for deep deserialization.
        
        Parameters:
          - d -- dict
        Returns:
          DecisionResult
            the object, may be None
        """
        if d is None:
            return None
        else:
            tmp = dict()
            result = DecisionResultImpl()
            for key in d:
                k = "_" + str(key) # by generation convention
                tmp[k] = d[key]
            if "_error" in tmp:
                tmplist = tmp["_error"]
                tmp["_error"] = []
                for i in tmplist: 
                    tmp["_error"].append(i)
                    
            if "_errorConfidence" in tmp:
                tmplist = tmp["_errorConfidence"]
                tmp["_errorConfidence"] = []
                for i in tmplist: 
                    tmp["_errorConfidence"].append(i)
                    
            if "_img1Error" in tmp:
                tmplist = tmp["_img1Error"]
                tmp["_img1Error"] = []
                for i in tmplist: 
                    tmp["_img1Error"].append(i)
                    
            if "_img2Error" in tmp:
                tmplist = tmp["_img2Error"]
                tmp["_img2Error"] = []
                for i in tmplist: 
                    tmp["_img2Error"].append(i)
                    
            if "_img3Error" in tmp:
                tmplist = tmp["_img3Error"]
                tmp["_img3Error"] = []
                for i in tmplist: 
                    tmp["_img3Error"].append(i)
                    
            if "_imageUri" in tmp:
                tmplist = tmp["_imageUri"]
                tmp["_imageUri"] = []
                for i in tmplist: 
                    tmp["_imageUri"].append(i)
                    
            
            
            
            
            result.__dict__ = tmp
            return result
    
    def writeToDecisionResult(o: DecisionResult) -> dict:
        """Turns an object of type DecisionResult into a dict for serialization.
        
        Parameters:
          - o -- the object, may be None
        Returns:
          dict
            the dict, may be None
        """
        if o is None:
            return None
        else:
            result = dict()
            for key in o.__dict__:
                k = key[1:] # by generation convention
                result[k] = o.__dict__[key]

DecisionResultSerializer()
