from json import JSONEncoder
import json
from datetime import datetime
from TypeTranslatorToString import TypeTranslatorToString
import Registry
from datatypes.LenzeDriveMeasurementProcess import LenzeDriveMeasurementProcess
from datatypes.LenzeDriveMeasurementProcessImpl import LenzeDriveMeasurementProcessImpl









from datatypes.LenzeDriveMeasurementChannel import LenzeDriveMeasurementChannel

from serializers.LenzeDriveMeasurementChannelSerializer import LenzeDriveMeasurementChannelSerializer


class LenzeDriveMeasurementProcessEncoder(JSONEncoder):
    """JSON encoder class for LenzeDriveMeasurementProcess.
    Generated by: EASy-Producer."""

    def default(self, o):
        """Provides access to the attributes in o.
        
        Parameters:
          - o -- the object to serialize
        Returns:
          dict
            the attributes
        """
        tmp = dict()
        for key in o.__dict__:
            k = key[1:] # by generation convention
            tmp[k] = o.__dict__[key]
        
        return tmp
    

class LenzeDriveMeasurementProcessSerializer(TypeTranslatorToString):
    """JSON transport serializer for LenzeDriveMeasurementProcess.
       Generated by: EASy-Producer."""
                
    def __init__(self):
        """Initializes the transformer.""" 
        Registry.serializers["LenzeDriveMeasurementProcess"] = self
        Registry.types[LenzeDriveMeasurementProcess] = "LenzeDriveMeasurementProcess"
        Registry.serializers["LenzeDriveMeasurementProcessImpl"] = self # there is a serializer for the Impl
        Registry.types[LenzeDriveMeasurementProcessImpl] = "LenzeDriveMeasurementProcess" # the Impl maps back to the type name
    
    def readFrom(self, data: str) -> LenzeDriveMeasurementProcess:
        """Turns bytes into a String.
        
        Parameters:
          - data -- the data string
        Returns:
          object
            the deserialized object
        """
    
        result = LenzeDriveMeasurementProcessImpl()
        jTmp = json.loads(data)
        tmp = dict()
        for key in jTmp:
            k = "_" + str(key) # by generation convention
            tmp[k] = jTmp[key]
        if "_channels" in tmp:
            tmplist = tmp["_channels"]
            tmp["_channels"] = []
            for i in tmplist: 
                tmp["_channels"].append(LenzeDriveMeasurementChannelSerializer.readFromLenzeDriveMeasurementChannel(i))
                
        
        result.__dict__ = tmp
        return result

    def writeTo(self, source: LenzeDriveMeasurementProcess) -> str:
        """Turns an object into a String.
        
        Parameters:
          - source -- the object
        Returns:
          bytes
            the serialized data string
        """
        
        return LenzeDriveMeasurementProcessEncoder().encode(source).encode("UTF-8").decode()
        
    def readFromLenzeDriveMeasurementProcess(d: dict) -> LenzeDriveMeasurementProcess:
        """Turns a dict into an object of type LenzeDriveMeasurementProcess for deep deserialization.
        
        Parameters:
          - d -- dict
        Returns:
          LenzeDriveMeasurementProcess
            the object, may be None
        """
        if d is None:
            return None
        else:
            tmp = dict()
            result = LenzeDriveMeasurementProcessImpl()
            for key in d:
                k = "_" + str(key) # by generation convention
                tmp[k] = d[key]
            if "_channels" in tmp:
                tmplist = tmp["_channels"]
                tmp["_channels"] = []
                for i in tmplist: 
                    tmp["_channels"].append(LenzeDriveMeasurementChannelSerializer.readFromLenzeDriveMeasurementChannel(i))
                    
            
            result.__dict__ = tmp
            return result
    
    def writeToLenzeDriveMeasurementProcess(o: LenzeDriveMeasurementProcess) -> dict:
        """Turns an object of type LenzeDriveMeasurementProcess into a dict for serialization.
        
        Parameters:
          - o -- the object, may be None
        Returns:
          dict
            the dict, may be None
        """
        if o is None:
            return None
        else:
            result = dict()
            for key in o.__dict__:
                k = key[1:] # by generation convention
                result[k] = o.__dict__[key]

LenzeDriveMeasurementProcessSerializer()
