from json import JSONEncoder
import json
from datetime import datetime
from TypeTranslatorToString import TypeTranslatorToString
import Registry
from datatypes.LenzeDriveMeasurement import LenzeDriveMeasurement
from datatypes.LenzeDriveMeasurementImpl import LenzeDriveMeasurementImpl









from datatypes.LenzeDriveMeasurementChannel import LenzeDriveMeasurementChannel

from serializers.LenzeDriveMeasurementChannelSerializer import LenzeDriveMeasurementChannelSerializer
from datatypes.LenzeDriveMeasurementProcess import LenzeDriveMeasurementProcess

from serializers.LenzeDriveMeasurementProcessSerializer import LenzeDriveMeasurementProcessSerializer


class LenzeDriveMeasurementEncoder(JSONEncoder):
    """JSON encoder class for LenzeDriveMeasurement.
    Generated by: EASy-Producer."""

    def default(self, o):
        """Provides access to the attributes in o.
        
        Parameters:
          - o -- the object to serialize
        Returns:
          dict
            the attributes
        """
        tmp = dict()
        for key in o.__dict__:
            k = key[1:] # by generation convention
            tmp[k] = o.__dict__[key]
        if "_PROCESS" in tmp:
            tmp["_PROCESS"] = LenzeDriveMeasurementProcessSerializer.writeToLenzeDriveMeasurementProcess(tmp["_PROCESS"])
        
        return tmp
    

class LenzeDriveMeasurementSerializer(TypeTranslatorToString):
    """JSON transport serializer for LenzeDriveMeasurement.
       Generated by: EASy-Producer."""
                
    def __init__(self):
        """Initializes the transformer.""" 
        Registry.serializers["LenzeDriveMeasurement"] = self
        Registry.types[LenzeDriveMeasurement] = "LenzeDriveMeasurement"
        Registry.serializers["LenzeDriveMeasurementImpl"] = self # there is a serializer for the Impl
        Registry.types[LenzeDriveMeasurementImpl] = "LenzeDriveMeasurement" # the Impl maps back to the type name
    
    def readFrom(self, data: str) -> LenzeDriveMeasurement:
        """Turns bytes into a String.
        
        Parameters:
          - data -- the data string
        Returns:
          object
            the deserialized object
        """
    
        result = LenzeDriveMeasurementImpl()
        jTmp = json.loads(data)
        tmp = dict()
        for key in jTmp:
            k = "_" + str(key) # by generation convention
            tmp[k] = jTmp[key]
        if "_PROCESS" in tmp:
            tmp["_PROCESS"] = LenzeDriveMeasurementProcessSerializer.readFromLenzeDriveMeasurementProcess(tmp["_PROCESS"])
        
        result.__dict__ = tmp
        return result

    def writeTo(self, source: LenzeDriveMeasurement) -> str:
        """Turns an object into a String.
        
        Parameters:
          - source -- the object
        Returns:
          bytes
            the serialized data string
        """
        
        return LenzeDriveMeasurementEncoder().encode(source).encode("UTF-8").decode()
        
    def readFromLenzeDriveMeasurement(d: dict) -> LenzeDriveMeasurement:
        """Turns a dict into an object of type LenzeDriveMeasurement for deep deserialization.
        
        Parameters:
          - d -- dict
        Returns:
          LenzeDriveMeasurement
            the object, may be None
        """
        if d is None:
            return None
        else:
            tmp = dict()
            result = LenzeDriveMeasurementImpl()
            for key in d:
                k = "_" + str(key) # by generation convention
                tmp[k] = d[key]
            if "_PROCESS" in tmp:
                tmp["_PROCESS"] = LenzeDriveMeasurementProcessSerializer.readFromLenzeDriveMeasurementProcess(tmp["_PROCESS"])
            
            result.__dict__ = tmp
            return result
    
    def writeToLenzeDriveMeasurement(o: LenzeDriveMeasurement) -> dict:
        """Turns an object of type LenzeDriveMeasurement into a dict for serialization.
        
        Parameters:
          - o -- the object, may be None
        Returns:
          dict
            the dict, may be None
        """
        if o is None:
            return None
        else:
            result = dict()
            for key in o.__dict__:
                k = key[1:] # by generation convention
                result[k] = o.__dict__[key]

LenzeDriveMeasurementSerializer()
