from json import JSONEncoder
import json
from datetime import datetime
from TypeTranslatorToString import TypeTranslatorToString
import Registry
from datatypes.PlcEnergyMeasurementDatapointsJson import PlcEnergyMeasurementDatapointsJson
from datatypes.PlcEnergyMeasurementDatapointsJsonImpl import PlcEnergyMeasurementDatapointsJsonImpl





from datatypes.PlcEnergyMeasurementListOfDataPointJson import PlcEnergyMeasurementListOfDataPointJson

from serializers.PlcEnergyMeasurementListOfDataPointJsonSerializer import PlcEnergyMeasurementListOfDataPointJsonSerializer


class PlcEnergyMeasurementDatapointsJsonEncoder(JSONEncoder):
    """JSON encoder class for PlcEnergyMeasurementDatapointsJson.
    Generated by: EASy-Producer."""

    def default(self, o):
        """Provides access to the attributes in o.
        
        Parameters:
          - o -- the object to serialize
        Returns:
          dict
            the attributes
        """
        tmp = dict()
        for key in o.__dict__:
            k = key[1:] # by generation convention
            tmp[k] = o.__dict__[key]
        
        return tmp
    

class PlcEnergyMeasurementDatapointsJsonSerializer(TypeTranslatorToString):
    """JSON transport serializer for PlcEnergyMeasurementDatapointsJson.
       Generated by: EASy-Producer."""
                
    def __init__(self):
        """Initializes the transformer.""" 
        Registry.serializers["PlcEnergyMeasurementDatapointsJson"] = self
        Registry.types[PlcEnergyMeasurementDatapointsJson] = "PlcEnergyMeasurementDatapointsJson"
        Registry.serializers["PlcEnergyMeasurementDatapointsJsonImpl"] = self # there is a serializer for the Impl
        Registry.types[PlcEnergyMeasurementDatapointsJsonImpl] = "PlcEnergyMeasurementDatapointsJson" # the Impl maps back to the type name
    
    def readFrom(self, data: str) -> PlcEnergyMeasurementDatapointsJson:
        """Turns bytes into a String.
        
        Parameters:
          - data -- the data string
        Returns:
          object
            the deserialized object
        """
    
        result = PlcEnergyMeasurementDatapointsJsonImpl()
        jTmp = json.loads(data)
        tmp = dict()
        for key in jTmp:
            k = "_" + str(key) # by generation convention
            tmp[k] = jTmp[key]
        if "_ListOfDataPoints" in tmp:
            tmplist = tmp["_ListOfDataPoints"]
            tmp["_ListOfDataPoints"] = []
            for i in tmplist: 
                tmp["_ListOfDataPoints"].append(PlcEnergyMeasurementListOfDataPointJsonSerializer.readFromPlcEnergyMeasurementListOfDataPointJson(i))
                
        
        result.__dict__ = tmp
        return result

    def writeTo(self, source: PlcEnergyMeasurementDatapointsJson) -> str:
        """Turns an object into a String.
        
        Parameters:
          - source -- the object
        Returns:
          bytes
            the serialized data string
        """
        
        return PlcEnergyMeasurementDatapointsJsonEncoder().encode(source).encode("UTF-8").decode()
        
    def readFromPlcEnergyMeasurementDatapointsJson(d: dict) -> PlcEnergyMeasurementDatapointsJson:
        """Turns a dict into an object of type PlcEnergyMeasurementDatapointsJson for deep deserialization.
        
        Parameters:
          - d -- dict
        Returns:
          PlcEnergyMeasurementDatapointsJson
            the object, may be None
        """
        if d is None:
            return None
        else:
            tmp = dict()
            result = PlcEnergyMeasurementDatapointsJsonImpl()
            for key in d:
                k = "_" + str(key) # by generation convention
                tmp[k] = d[key]
            if "_ListOfDataPoints" in tmp:
                tmplist = tmp["_ListOfDataPoints"]
                tmp["_ListOfDataPoints"] = []
                for i in tmplist: 
                    tmp["_ListOfDataPoints"].append(PlcEnergyMeasurementListOfDataPointJsonSerializer.readFromPlcEnergyMeasurementListOfDataPointJson(i))
                    
            
            result.__dict__ = tmp
            return result
    
    def writeToPlcEnergyMeasurementDatapointsJson(o: PlcEnergyMeasurementDatapointsJson) -> dict:
        """Turns an object of type PlcEnergyMeasurementDatapointsJson into a dict for serialization.
        
        Parameters:
          - o -- the object, may be None
        Returns:
          dict
            the dict, may be None
        """
        if o is None:
            return None
        else:
            result = dict()
            for key in o.__dict__:
                k = key[1:] # by generation convention
                result[k] = o.__dict__[key]

PlcEnergyMeasurementDatapointsJsonSerializer()
